XIncludeFile "WIA-Wrapper.pbi"

#Window = 0
#Treegagdet = 1

If OpenWindow(#Window, 10,10,400,300,"List All WIA-Devices with Properties")
  TreeGadget(#Treegagdet, 0,0,400,300)
EndIf



If InitWIA() ;We try to initialize the WIA-Api
  
  ;With that we look for all devices and what preferences they have
  If ExamineWIADevices() ;Prepair to get Infos about devices. This function returns also the number of devices.
    While NextWIADevice()
      
      AddGadgetItem(#Treegagdet, -1, GetWIADeviceName(),#False,0)
      Debug GetWIADeviceName()
      AddGadgetItem(#Treegagdet, -1, "DeviceID: " + GetWIADeviceID(),#False,1)
      Debug GetWIADeviceID()
      AddGadgetItem(#Treegagdet, -1, "DeviceType: " + Str(GetWIADeviceType()),#False,1)
      Debug GetWIADeviceType() ; Could be #WIA_UnspecifiedDeviceType, #WIA_ScannerDeviceType, #WIA_CameraDeviceType or #WIA_VideoDeviceType 
      
      AddGadgetItem(#Treegagdet, -1, "Properties",#False,1)
      If ExamineWIADeviceProperties()
        
        While NextWIADeviceProperty()
          
          AddGadgetItem(#Treegagdet, -1, GetWIADevicePropertyName(),#False,2)
          Debug GetWIADevicePropertyName()
          
          Select GetWIADevicePropertyType() ;There are more types, but most of the time these are enought
            Case #WIA_BooleanPropertyType To #WIA_DoublePropertyType
              AddGadgetItem(#Treegagdet, -1, "Int: " + Str(GetWIADevicePropertyInteger()),#False,3)
              Debug GetWIADevicePropertyInteger()
            Case #WIA_StringPropertyType
              AddGadgetItem(#Treegagdet, -1, "Str: " + GetWIADevicePropertyString(),#False,3)
              Debug GetWIADevicePropertyString()
          EndSelect
          
        Wend
        
      EndIf
      
    Wend
    
  Else
    MessageRequester("No Device", "There is currently no Image-Device connected. Make sure they are connected and powered on.", #MB_ICONSTOP)
  EndIf
  
  
Else
  MessageRequester("Fatal Error", "Couldn't initialize WIA. You need at least Windows XP with Service Pack 1 to use this Software!", #MB_ICONSTOP)
EndIf

Repeat 
  Event = WaitWindowEvent()
  
Until Event = #PB_Event_CloseWindow
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 14
; FirstLine = 14
; EnableXP